// 
// The LibSea Graph Library.
// Copyright (C) 2000,2001,2002 The Regents of the University of California.
// 
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
// 
// ######END_HEADER######
// 


package org.caida.libsea;

public interface AttributeDefinitionIterator extends Iterator
{
    boolean  isMutable();
    int      getID();
    String   getName();
    ValueType  getType();
    int  getEnumeration();
    String   getDefault();
    AttributesByAttributeIterator  getAttributes();
    AttributesByAttributeIterator  getNodeAttributes();
    AttributesByAttributeIterator  getLinkAttributes();
    AttributesByAttributeIterator  getPathAttributes();
    AttributesByAttributeIterator  getObjectAttributes(ObjectType type);

    void     setName(String name)
	throws DuplicateObjectException;
    void     setType(ValueType type, String enumeration);
    void     setDefault(String expr);

    void     removeDefault();
    void     removeAttributes();
    void     removeAttributeDefinition();
    void     addAttributeDefinition(String name, ValueType type,
				    String enumeration, String expr)
	throws DuplicateObjectException;
    void     addMutableAttributeDefinition(String name, ValueType type,
					   String enumeration, String expr,
					   boolean node, boolean link,
					   boolean path)
	throws DuplicateObjectException;
}
