// 
// The LibSea Graph Library.
// Copyright (C) 2000,2001,2002 The Regents of the University of California.
// 
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
// 
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
// 
// ######END_HEADER######
// 


package org.caida.libsea;

import java.io.*;

class SimpleIOTester
{
    public static void main(String[] args)
    {
        try
        {
	    SimpleIOTester tester = new SimpleIOTester(System.in, System.out);
	    tester.test(true);
        }
        catch(Exception e)
        {
	    e.printStackTrace();
            System.err.println("ERROR: " + e);
        }        
    }

    public SimpleIOTester(InputStream in, OutputStream out)
    {
        m_in = new DataInputStream(in);
        m_out = new BufferedWriter(new OutputStreamWriter(out));
    }

    public void test(boolean isVerbose)
        throws Exception
    {
	GraphBuilder builder = GraphFactory.makeImmutableGraph();

	GraphFileLexer lexer = new GraphFileLexer(m_in);
	GraphFileParser parser = new GraphFileParser(lexer);
	parser.file(builder);

	Graph graph = builder.endConstruction();
            
	GraphFileWriter writer =
	    new GraphFileWriter(m_out, graph, isVerbose, false);
	writer.write();
    }

    private DataInputStream  m_in;
    private Writer  m_out;
}
